Блог пользователя awoo

Автор awoo, история, 5 лет назад, По-русски

1140A - Детектив

Разбор
Решение (adedalic)

1140B - Хорошая строка

Разбор
Решение (Roms)

1140C - Плейлист

Разбор
Решение (Roms)

1140D - Минимальная триангуляция

Разбор
Решение (adedalic)

1140E - Беспалиндромные массивы

Разбор
Решение (adedalic)

1140F - Расширение множества точек

Разбор
Решение (BledDest)

1140G - Двойное дерево

Разбор
Решение (BledDest)
  • Проголосовать: нравится
  • +69
  • Проголосовать: не нравится

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

51769222 this is my submission for problem c why is it giving wrong answer

  • »
    »
    5 лет назад, # ^ |
    Rev. 2   Проголосовать: нравится +4 Проголосовать: не нравится

    Because long somtimes is just int. So to prevent this mistake everytime write "long long". UPD: When you think int isn't enough

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

In Problem D, yes I got AC with greedy solution but How to Do using DP (recursive approach)

At first during contest i started to solve this question as top down dp(recursive), but i was not able to solve.. can someOne give there dp recursive solution..

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится -30 Проголосовать: не нравится

    dp[3]=6 dp[i]=dp[i-1]+(i*(i-1)) dp[N] is the answer. Hope that helps

    • »
      »
      »
      5 лет назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      @bhatnagar.mradul bro u are trying to implement that greedy solution using dp.. i dont mean that..

      i want to know that O(n^3) solution using recursive dp

      • »
        »
        »
        »
        5 лет назад, # ^ |
          Проголосовать: нравится +1 Проголосовать: не нравится

        I used O(N^2) dp

        dp[i][j] means answer for polygon that is made from this points -> [1,2...i] and [n,n-1,...j].

        dp[i+1][j]=min(dp[i+1][j],dp[i][j]+i*(i+1)*j)
        dp[i][j-1]=min(dp[i][j-1],dp[i][j]+i*(j-1)*j)

        You need to update answer when i+1==j-1.
        My solution.

    • »
      »
      »
      5 лет назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      :\

  • »
    »
    5 лет назад, # ^ |
    Rev. 2   Проголосовать: нравится +7 Проголосовать: не нравится

    Keep two pointers as state. dp[i][j] should have the optimal total cost of triangulation of the polygon with { i, i+1, i+2, ..., j-1, j } vertices. To calculate dp[i][j] you have to take the line i-j at some point in a triangle. Pick a vertex k such that i < k < j and make a triangle { i, j, k }.

    So dp[i][j] = min { i*j*k + dp[i][k] + dp[k][j] } for all k such that i < k < j.

    Result is dp[1][n]. Code if needed.

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

can F be solved with sqrt-dynamic connectivity trick?

  • »
    »
    5 лет назад, # ^ |
    Rev. 2   Проголосовать: нравится +10 Проголосовать: не нравится

    I tried, but I haven't managed to squeeze my $$$O(q^{1.5})$$$ implementation in time limit. But it doesn't mean that it's impossible, considering my optimization skills.

    Sometimes actually $$$O(q^{1.5} \log q)$$$ version can be faster, maybe I'll try that.

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    can I find any tutorial for that ?

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Problem C, editorial:

This can be done using some standard containers: set in C++

multiset, because two songs can be equal

»
5 лет назад, # |
Rev. 2   Проголосовать: нравится +6 Проголосовать: не нравится

In problem E, What is the difference between l is odd and l is even ? I think the way to compute cntDiff and cntSame when l is odd is similar when l is even ?

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    when l is odd then (**#**) you can't split it into tow same segment . the different of those just that .

    • »
      »
      »
      5 лет назад, # ^ |
        Проголосовать: нравится +3 Проголосовать: не нравится

      I mean we can use recipe when l is even for both case,can't we?

      • »
        »
        »
        »
        5 лет назад, # ^ |
          Проголосовать: нравится +3 Проголосовать: не нравится

        You can, but it will drop complexity from $$$O(\log{l})$$$ to $$$O(l)$$$. It doesn't matter in this specific task, but it worse overall.

»
5 лет назад, # |
  Проголосовать: нравится +3 Проголосовать: не нравится

can anyone explain the problem E , i didn't understood the editorial

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится +9 Проголосовать: не нравится

    If you have palindrome of size ODDNUMBER, you also have palindrome of size ODDNUMBER — 2. So you just avoid palindromes of length 3 and that's enough.

    Split the array A into two smaller arrays ODD and EVEN, odd indices goes into ODD, even indices go into EVEN. You want to answer this question:

    "How many ways are there to fill in -1, so that no adjacent numbers are the same"

    Solve that question for the two arrays, final answer is simply solve(EVEN)*solve(ODD)

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

For the solution of problem C, what if the erased item from the set is actually the one just inserted? e.g., suppose we insert one a[i] that has the smallest beauty as well as the shortest length, and if the set size exceeds k, the element that will be popped out will be a[i]. But at the end of this iteration, we compute the score by a[i].first still, which is formally wrong.

But this may not cause trouble: since sum doesn't change in this case, and a[i].first should be smaller than any song in the set, so that a[i].first * sum <= min_beauty(s).first * sum; this implies that the maximal value won't be polluted by a[i].first * sum, and the actual score has been considered.

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    Great observation!

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    can u please give some mathematical proof of C.. that is why we sort on the basis of beauty.. in my opinion if we multiply beauty and length and then sort is it work???.... plz help me?? I can't understand...Thanks

»
5 лет назад, # |
  Проголосовать: нравится +16 Проголосовать: не нравится

Probably the best solution for Problem D. here:- https://codeforces.com/contest/1140/submission/51801930

Approach For n = 3 the cut will 1-3. ans = 1*2*3

For n = 4 the cuts will be 1-3, 1-4. ans = 1*2*3 + 1*3*4

for n = 5 the cuts will be 1-3, 1-4, 1-5. ans = 1*2*3 + 1*3*4 + 1*4*5

If we look at the pattern then for n = N, the ans will be 1*2*3 + 1*3*4 + 1*4*5 + 1*5*6 + ... + 1*(N-1)*(N) which can be written as sum from n = 2 to N : n(n+1)

changing limit of n from 2 to 1, we need to subtract 1*2, i.e 2 from the result

(sum from n = 1 to N : n(n+1) )- 2 (sum from n = 1 to N : n^2 + n) — 2

sum from n = 1 to N : n^2 = (n(n+1)(2n+1))/6 sum from n = 1 to N : n = (n(n+1))/2 ans = (n(n+1)(2n+1))/6 + (n(n+1))/2 — 2;

ans = (n(n+1)(n+2))/3 — 2;

all you need to do is take the input n, decrement n by 1; ans use the above formula.

Time Complexity — O(1) Space Complexity — O(1)

»
5 лет назад, # |
Rev. 7   Проголосовать: нравится 0 Проголосовать: не нравится

.

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Can anybody please explain G's solution? I'm not getting the editorial.

  • »
    »
    5 лет назад, # ^ |
    Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится
    1. First we need to find the shortest path between nodes of the form $$$2i-1$$$ to $$$2i$$$. This can be done with a dp on the tree. Notice that any such shortest path will only take one edge between the even tree and the odd tree. Simply replacing the cross edge distance will not change shortest distances, and will make reasoning through the problem easier.

    2. Next to find shortest paths, if you use centroid decomposition we can find shortest path from root to a node by:

    • dp[i][j] defined to be the length of the shortest path from node $$$2i-j$$$ to the root with another tree dp.

    If you use binary jumping, you can use: - dp[i][j][k][l] defined to be the the distance from $$$2i-j$$$ to the $$$2^l$$$ th ancestor in either the even or odd tree (kept track of by k).

    I personally find binary jumping easier. Either way, this uses the critical observation that if you want to find the path from one node to another, you need to pass through the simple path on the tree between the two nodes (possibly jumping back and forth between the trees).

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

In the end we need to find a way to calculate the number of those sequences. There are only two fundamental types of sequences: (a == b) and (a != b). Exact values of a and b don't really matter

I believe this part can be simplified a bit. Write the usual dynamic dp[n][k] and notice that we actually need only 2 states instead of k: dp[i][j == a] and dp[i][j != a]

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

In Problem E, How do we get cntSame(0) = 0 and cntDiff(0) = 1 and how this relation is coming out when l is even or odd. Can someone explain with example.

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится +3 Проголосовать: не нравится

    cntSame(0) = 0 since there is no way to make 'aa' have all pairs of consecutive elements are distinct. cntDiff(0) = 1 since there is one way to make 'ab' have all pairs of consecutive elements are distinct.

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Why don't precompute values cntSame and cntDiff for every 1<=i<=n in O(n) using dp?

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

In F, it says "...using path compression in DSU here is meaningless...". Is it meaningless? I think it can actually make the solution slower, since path compression is amortized, and if the structure allows undoing operations, then amortization should fail (might give TLE on countertests).

»
5 лет назад, # |
  Проголосовать: нравится +8 Проголосовать: не нравится

In problem E, there is no need to make separate recurrence relation for odd and even lengths as mentioned in the tutorial. The one for even length is enough to get for the odd length.

cntSame(l)=(k−1)⋅cntDiff(l−1)

cntDiff(l)=cntSame(l−1)+(k−2)⋅cntDiff(l−1).

link to the code

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    Sorry to bother you, could you explain how did you get that recurrence on problem E? I'm having trouble on find it.

    • »
      »
      »
      5 лет назад, # ^ |
        Проголосовать: нравится +13 Проголосовать: не нравится

      theProcess Consider a -1 -1 ...ltimes... -1 -1 b

      You need to find the no. of arrays in which no two consecutive elements are equal.

      So first if you assign the value to the lth "-1" element i.e. element before b, obviously you can assign all the values to it from 1 to k, except b. You can't assign b to it because no two consecutive elements should be equal. So there are (k-1) ways in which you can assign the value to lth "-1" element.

      Now I hope you know the meaning of cntSame(l), and cntDiff(l).

      To calculate cntSame(l), consider what happens when a=b.

      Suppose you assign value to p to the lth "-1" element. Obviously, p!=b.

      Since a=b, therefore p!=a. So, remaining number of values will be (k-1) i.e. except a(or b, since a=b). Therefore cntSame(l) = (k-1)*cntDiff(l-1)

      To calculate cntDiff(l), consider what happens when a!=b.

      Suppose you assign value to p to the lth "-1" element. Obviously, p!=b.

      Since a!=b, You can either assign p=a or p!=a. There will be exactly one case to assign p=a and (k-2) cases to assign p!=a. (k-2 because you cannot also assign p=b)

      Therefore cntDiff(l) = cntSame(l-1) + (k-2)*cntDiff(l-1)

»
5 лет назад, # |
  Проголосовать: нравится +1 Проголосовать: не нравится

I read many solutions for problem E. What I understood is we have to find continuous sequences of -1 for even and odd positions separately and apply recurrence to calculate number of ways such that consecutive numbers should be different and multiply results for both even and odd positions. What I didn't understood is how numbers other than -1 affect the total number of ways and how recurrence works for them. Can anyone please explain it ?

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

In problem C When we sliding the window for the sum of length, shouldn't we include the current element with least beauty value? I mean, what we're really finding is the most (k-1) elements we've searched before but not k because the length of ith one is included must?

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    https://codeforces.com/contest/1140/submission/52462663

    yes the length of the i'th one must be included.

    so the idea is to consider every i'th element as the minimum beauty. for this we sort the songs in descending order of beauty. so the first song we consider will have the highest beauty. (what if 2 songs have same beauty? read last 2 para)

    we will at all times try to maintain a list of songs of size at most k. this list will contain at most k songs with the highest length, not including the current i'th song. so if we already have a list of size k, then we remove the song with the smallest length. so size become k-1. then we include the current song into the list, size becomes k, and update our maxTillNow. if out list is less than k, then we just simply include the song and update maxTillNow.

    to maintain this list we will use a priority_queue (min heap), where the top element is the song with the smallest length. this way we don't need to keep track of song indexes.

    while sorting our list of songs in descending order of beauty, if 2 songs have the same beauty we place the song with the smaller length first (this is very important). this is because when we consider the i'th beauty, obviously the i'th length must also be included. which means, if there is already a song in the list with the same beauty as our current minimum beauty we need to pick the one with the smaller length to discard.

    this process becomes easier to deal with for 2 or more songs with same beauty, if we consider the song with the greater length as late as possible. because the song with the smaller length will already be in the list, so we can simply discard it and include the current song.

    read code for more clarity.

»
5 лет назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

Can anyone tell the complexity of the for loop dealing with set in C?

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    only 1 time loop will execute for each outer loop. So we could have used if condition (instead of iterating over set) as well because at a time, its gauranteed, set size can only be 'k' at max, since we are increasing set size by 1 in each outer loop iteations.

»
5 лет назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

why I don't understand the Problem B.I think the answer of string "<<<<>>>>" should be 1,because we can do some operations,finally the string will be "<>",then the answer is 1 .

  • »
    »
    5 лет назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    You may remove some characters from the string before applying the operations.

    • »
      »
      »
      5 лет назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      Oh,thank you very much

    • »
      »
      »
      5 лет назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      In problem C,I cannot understand why the does the set use pair<int,int> instead of int .In other words,if I submit my code with set 《int》 ,then I will wrong on test 3 .It seems that we haven't utilize the second of the pair<int,int>. Sorry for my poor English.

      • »
        »
        »
        »
        5 лет назад, # ^ |
          Проголосовать: нравится 0 Проголосовать: не нравится

        Set does not contain duplicate elements. but we need to store it. pair<int,int> is used for this reason. Because index itself is stored with the beauty value, there is no chance for duplicate elements.

»
5 лет назад, # |
  Проголосовать: нравится -10 Проголосовать: не нравится

My opinion may be subjective, but problem A was very poorly written and hard to comprehend exactly what is being asked.

»
4 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

In problem C, in the given solution what if the erase operation removes the chosen element or the element who beauty is minimum. Because we have to consider, the element having minimum beauty in the set but the solution doesn't seem to be doing so.

»
4 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится
»
4 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится
»
4 года назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

In problem C when I used set st it wont work but if I use set<pair<int,int>>st it does work

  • »
    »
    4 года назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    Set does not contain duplicate elements. but we need to store it. pair<int,int> is used for this reason. Because index itself is stored with the beauty value, there is no chance for duplicate elements.(copied)

»
4 года назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

in 1140C can anybody tell what is the use making PAIR there. its giving wrong answer of 3rd testcase if I am not making a paired set.

»
3 года назад, # |
Rev. 3   Проголосовать: нравится +8 Проголосовать: не нравится

I'm a bit confused on problem G's solution. As an example, on a normal tree, how could we precompute the distance from each centroid to every node in its centroid decomposition subtree? I can think of a brute force $$$O(nlog^2_2n)$$$ solution using a method like binary jumping and precomputing all the possibilities, but this pretty much defeats the purpose of using centroid decomposition to solve this problem. Is there some sort of efficient $$$O(nlog_2 n)$$$ DFS solution that I'm missing? Thanks in advance

Edit: I figured it out already